package Base;
use strict;

use LWP::UserAgent;

sub new {
   my $proto = shift;
   my $class = ref($proto) || $proto;
   my $self = {
      g		=> shift,
      indexing	=> shift,
      indexer   => shift,
      file	=> shift,
      filetype  => shift,
      conts	=> '',
      title 	=> '',
      desc	=> '',
      key	=> '',
      body	=> '',
   };
   bless ($self, $class);
   $self->decide;
   return $self;
}

sub decide {
   my $self = shift; 
   if ($self->{filetype} eq "local") {
      # Decide if the current index key is a current file or remote file
      $self->_file($self->{file});
   }
   elsif ($self->{filetype} eq "network") {
      $self->_network($self->{file});
   }
   else {
       die "Illegal filetype";
   }
}

sub _network {
    my $self = shift;
    my $file = shift;
    my $ua = new LWP::UserAgent;
    $ua->agent('Swat 3.0 Beta 3');
    $ua->from($self->{g}{email});
    $ua->timeout($self->{indexer}{timeout});
    my $request = HTTP::Request->new('GET', $file);
    my $res = $ua->request($request);
    if ($res->is_success) {
       $self->{conts} = $res->content;
       $self->initialize();
    }
}

sub _file {
   my $self = shift;
   my $file = shift;
   my $length = -1;
   die "Could not retrieve file $file for indexing" unless (open(FILE, $file));
   my @contents = <FILE>;
   $self->{conts} = join(/ /,@contents);
   @contents = undef;
   $self->initialize();
}
sub get_entry {
    my $self = shift;
    return ({'title' => $self->get_title(), 'desc' => $self->get_desc(), 'key' => $self->get_key(), 'body' => $self->get_body()});
}

sub get_title {
   my $self = shift;
   $self->{title} = $self->{file} unless ($self->{title});
   return \$self->{title};
}

sub get_desc {
   my $self = shift;
   $self->{desc} = "No Description Available" unless ($self->{desc});
   return \$self->{desc};
}
sub get_key {
   my $self = shift;
   $self->{key} = " " unless ($self->{key});
   return \$self->{key};
}
sub get_body {
   my $self = shift;
   $self->{body} = " " unless ($self->{body});
   return \$self->{body};
}
1;
